<?xml version="1.0"?>
<!-- This file is protected by Copyright. Please refer to the COPYRIGHT file
     distributed with this source distribution.

     This file is part of OpenCPI <http://www.opencpi.org>

     OpenCPI is free software: you can redistribute it and/or modify it under
     the terms of the GNU Lesser General Public License as published by the Free
     Software Foundation, either version 3 of the License, or (at your option)
     any later version.

     OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
     WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
     more details.

     You should have received a copy of the GNU Lesser General Public License
     along with this program. If not, see <http://www.gnu.org/licenses/>. -->
<application>
   <!-- Receive Chain for the ADSB Application-->
   <connection>
      <port instance='drc' name='rx' index="0"/>
      <port instance='multiply' name='input_1'/>
   </connection>
 
   <instance component="ocpi.comp.sdr.generator.constant_xs">
      <property name="real_value" value="20"/>
      <property name="imaginary_value" value="0"/>
   </instance>

   <connection>
      <port instance="constant_xs" name="output"/>
      <port instance="multiply" name="input_2"/>
   </connection>

   <instance component="ocpi.comp.sdr.math.complex_multiplier_scaled_xs" name="multiply" connect="magnitude">
      <property name="scale_output" value="0"/>
   </instance>

   <instance component="ocpi.examples.magnitude_squared_xs_s" name="magnitude" connect="moving_average_s" model="hdl"/>

   <instance component="ocpi.examples.moving_average_s">
      <property name='length' value='32'/>
   </instance>

   <connection>
      <port instance='moving_average_s' name='output_average'/>
      <port instance='preamble_detect' name='input_average'/>
   </connection>

   <connection>
      <port instance='moving_average_s' name='output_sample'/>
      <port instance='preamble_detect' name='input_sample'/>
   </connection>

   <instance component="ocpi.examples.adsb_preamble_detector_s" name="preamble_detect">
      <property Name='samp_per_symbol' Value='4'/>
   </instance>

   <connection>
     <port instance='preamble_detect' name='output'/>
     <port instance='ppm_demod' name='input'/>
   </connection>

   <instance component="ocpi.examples.ppm_demodulation_s_b" name='ppm_demod' connect='mla0'>
      <property name='samps_per_sym' value='4'/>
   </instance>

   <instance component="ocpi.comp.sdr.interface.message_length_adjuster" name="mla0">
      <property name="message_size" value="112"/>
   </instance>

   <connection>
      <port instance='mla0' name='output'/>
      <port instance='data_pack_b_uc' name='input'/>
   </connection>
  
   <instance component="ocpi.comp.sdr.communication.data_pack_b_uc" connect='mla1'/>

   <instance component="ocpi.comp.sdr.interface.message_length_adjuster" name="mla1" connect='crc_validator_uc'>
      <property name="message_size" value="14"/>
   </instance> 

   <instance component="ocpi.examples.crc_validator_uc" connect="file_write">
      <property name="crcBits" value="24"/>
      <property name="crcKey" value="0xFFF409"/>
   </instance>

  <instance component="ocpi.core.file_write" container="rcc0">
    <property name="filename" value="odata/crc_out.bin"/>
    <property name="messagesinfile" value="false"/>
  </instance>

   <!-- This DRC is setup to run at 1090 MHz and sample at 4 MHz or 4x Bandwidth -->
   <instance component="ocpi.platform.drc">
      <property name="configurations"
                value="{description first,channels {
           {   rx true,
               tuning_freq_mhz 1090.0,
               offset_freq_mhz 0.0,
               bandwidth_3db_mhz 4.0,
               sampling_rate_msps 4.0,
               samples_are_complex true,
               gain_mode auto,
               gain_db 0,
               tolerance_bandwidth_3db_mhz 0.01,
               tolerance_tuning_freq_mhz 0.01,
               tolerance_sampling_rate_msps 0.01,
               tolerance_gain_db 1}
           }
       }"/>
      <property name="start" value="0"/>
      <property name="tx_disable_on_flush" value="false"/>
      <property name="enable_rx" value="true"/>
      <property name="enable_tx" value="false"/>
   </instance>

</application>
